//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <math.h>
#pragma hdrstop

#include "PgpKeyGenDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpKeyGenDlg *PgpKeyGenDlg;
//---------------------------------------------------------------------------
bool __fastcall GenerateRSAKeyPair(TForm *Owner)
{
   PgpKeyGenDlg = new TPgpKeyGenDlg(Owner);
   CenterDialog(PgpKeyGenDlg,Owner);
   PgpKeyGenDlg->ShowModal();
   bool gen = PgpKeyGenDlg->ModalResult;
   delete PgpKeyGenDlg;
   return gen;
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyGenDlg::TPgpKeyGenDlg(TComponent* Owner)
  : TForm(Owner)
{
   Notebook->ActivePage = "Introduction";
   SetPassphraseHidden(true);
   Confirmation->Clear();
   Passphrase->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::NextBtnClick(TObject *Sender)
{
   int index = Notebook->PageIndex;
   if (index==1 && NameAddress->Text.IsEmpty())
   {
      MyBeep(0);
      MsgBoxHwnd(Handle,
         s("Each key must have an associated name.\n")+
         s("You must enter a name before continuing with key generation!"),
         s("PGP Key Generation"),
         MB_OK);
      return;
   }

   int customval = CustomBits->Text.ToIntDef(0);
   if (index==2 && ButCustom->Checked && (customval<768 || customval>2048))
   {
      MyBeep(0);
      MsgBoxHwnd(Handle,
         s("Bits value must be between 768 and 2048"),
         s("PGP Key Generation"),
         MB_OK);
      return;
   }

   if (index==3)
   {
      if (Passphrase->Text.Length()==0)
      {
         MsgBoxHwnd(Handle,
            s("No passphrase specified! You must enter\n")+
            s("a phrase before continuing."),
            s("PGP Key Generation"),
            MB_OK);
         ActiveControl = Passphrase;
         Confirmation->Clear();
         Passphrase->Clear();
         return;
      }
      if (Passphrase->Text!=Confirmation->Text)
      {
         MsgBoxHwnd(Handle,
            s("The passphrase you have entered has been rejected because\n")+
            s("your confirmation phrase does not match the original."),
            s("PGP Key Generation"),
            MB_OK);
         ActiveControl = Passphrase;
         Confirmation->Clear();
         Passphrase->Clear();
         return;
      }
      if (Passphrase->Text.Length()<8)
      {
         if (MsgBoxHwnd(Handle,
            s("Your passphrase is a security risk. It does not contain\n")+
            s("the minimum 8 characters.\n\n")+
            s("Continue with this passphrase?"),
            s("PGP Key Generation"),
            MB_YESNO)==IDNO)
         {
            ActiveControl = Passphrase;
            Confirmation->Clear();
            Passphrase->Clear();
            return;
         }
      }
   }

   // increment the page
   if (Notebook->PageIndex<4) Notebook->PageIndex++;

   index = Notebook->PageIndex;
   //if (index==1) NextBtn->Enabled = !NameAddress->Text.IsEmpty();

   if (index==2)
   {
   //   NextBtn->Enabled = !ButCustom->Checked || (customval>=768 && customval<=2048);
   }

   if (index==4)
   {
      AnsiString hider =
         s("#################################################################")+
         s("#################################################################");
      Memo3->Clear();
      Memo3->Lines->Add("NameAddress = "+NameAddress->Text);
      Memo3->Lines->Add("KeySize = "+
       s(But768->Checked  ? 768 :
         But1024->Checked ? 1024 :
         But1536->Checked ? 1536 :
         But2048->Checked ? 2048 :
         CustomBits->Text.ToIntDef(1024)));
      Memo3->Lines->Add("Passphrase = "+hider.SubString(1,Passphrase->Text.Length()));
   }

}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::BackBtnClick(TObject *Sender)
{
   if (Notebook->PageIndex>0) Notebook->PageIndex--;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::NotebookPageChanged(TObject *Sender)
{
   switch (Notebook->PageIndex)
   {
      case 0: BackBtn->Enabled = false; break;
      case 1:
         ActiveControl = NameAddress;
         BackBtn->Enabled = true;
         break;
      case 2: break;
      case 3: ActiveControl = Passphrase; break;
      case 4: ActiveControl = NextBtn;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel &&
       MsgBoxHwnd(this->Handle,
         "Cancel key pair generation?","Confirm",MB_YESNO)==IDNO)
   {
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::NameAddressChange(TObject *Sender)
{
//   NextBtn->Enabled = NameAddress->Text.Length();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::BitsButClick(TObject *Sender)
{
   if (ButCustom->Checked)
   {
      CustomBits->Enabled = true;
      CustomBits->Color = clWindow;
      CustomBits->Font->Color = clBlack;
      UpDown->Enabled = true;
   }
   else
   {
      CustomBits->Enabled = false;
      CustomBits->ParentColor = true;
      CustomBits->Font->Color = clGray;
      UpDown->Enabled = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::SetPassphraseHidden(bool hide)
{
   if (hide)
   {
      Confirmation->Font->Color = Passphrase->Color;
      Passphrase->Font->Color = Passphrase->Color;
   }
   else
   {
      Confirmation->Font->Color = clWindowText;
      Passphrase->Font->Color = clWindowText;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::HideBoxClick(TObject *Sender)
{
   SetPassphraseHidden(HideBox->Checked);
   ActiveControl = Passphrase;
}
//---------------------------------------------------------------------------
#define NUMRANGES	8
UINT PGPcomdlgPassphraseQualityXX(LPSTR szPhrase)
{
	UINT quality;
	unsigned short charIndex, rangeIndex, span;
	typedef struct ScoreStruct
	{
		unsigned char firstChar;
		unsigned char lastChar;
	} Range;
	static Range sRanges[] =
	{
		{ 0,		' ' - 1},
		{ ' ',		'A' - 1},
		{ 'A',		'Z'},
		{ 'Z' + 1,	'a' - 1},
		{ 'a',		'z'},
		{ '0',		'9'},
		{ 'z' + 1,	127},
		{ 128,		255},
	};
	BOOL haveRange[NUMRANGES];

  memset(haveRange,'\0',sizeof(haveRange));
//pgpClearMemory (haveRange, sizeof (haveRange));
	for (charIndex = 1; charIndex < lstrlen (szPhrase); ++charIndex) {
		for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex)	{
			UCHAR			theChar;
			Range *			theRange;
			
			theChar		= szPhrase[charIndex];
			theRange	= &sRanges[rangeIndex];

			if (theChar >= theRange->firstChar &&
				theChar <= theRange->lastChar)
			{
				haveRange[rangeIndex] = TRUE;
				break;
			}
		}
	}

	// determine the total span
	span = 0;
	for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex) {
		if (haveRange[rangeIndex]) {
			span += (unsigned short)(1+(sRanges[rangeIndex].lastChar-
				sRanges[rangeIndex].firstChar));
		}
	}

	if (span != 0) {
		double	bitsPerChar	= log (span) / log (2.0);  // base 2 log of span
		ULONG	totalBits	= (ULONG)(bitsPerChar * lstrlen (szPhrase));

		// assume a maximum quality of 128 bits
		quality = (totalBits * 100) / 128;
		if (quality > 100) quality = 100;
	}
	else {
		quality = 0;
	}

	return (quality);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDlg::PassphraseChange(TObject *Sender)
{
   ProgressBar1->Position = (short)
      PGPcomdlgPassphraseQualityXX(Passphrase->Lines->Text.c_str());
}
//---------------------------------------------------------------------------
